{*******************************************************************}
{                                                                   }
{       Developer Express Visual Component Library                  }
{       ExpressPrinting System COMPONENT SUITE                      }
{                                                                   }
{       Copyright (C) 1998-2010 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   (DCU, OBJ, DLL, ETC.) ARE CONFIDENTIAL AND PROPRIETARY TRADE    }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE EXPRESSPRINTINGSYSTEM AND            }
{   ALL ACCOMPANYING VCL CONTROLS AS PART OF AN                     }
{   EXECUTABLE PROGRAM ONLY.                                        }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}

unit dxPSdxSkinsHelperReg;

{$I cxVer.inc}

interface

uses
  Classes, DesignIntf, dxSkinsDesignHelperReg, dxPSCore;

procedure Register;

implementation

type

  { TdxSkinsPrintingSystemSelectionEditor }

  TdxSkinsPrintingSystemSelectionEditor = class(TdxSkinsBaseSelectionEditor)
  public
    procedure RequiresProductsUnits(Proc: TGetStrProc); override;
  end;

{ TdxSkinsPrintingSystemSelectionEditor }

procedure TdxSkinsPrintingSystemSelectionEditor.RequiresProductsUnits(Proc: TGetStrProc);
var
  AInfoClass: TdxPSPreviewDialogStyleInfoClass;
begin
  inherited RequiresProductsUnits(Proc);
  Proc('dxSkinscxPCPainter');
  if dxPSPreviewDialogManager.FindPreviewDialogStyleInfoByName('Advanced', AInfoClass) then
  begin
    Proc('dxSkinsdxBarPainter');
    Proc('dxBarSkinnedCustForm');
  end;
  if dxPSPreviewDialogManager.FindPreviewDialogStyleInfoByName('Ribbon', AInfoClass) then
  begin
    Proc('dxSkinsdxRibbonPainter');
    Proc('dxBarSkinnedCustForm');
  end;
end;

procedure Register;
begin
{$IFDEF DELPHI9}
  ForceDemandLoadState(dlDisable);
{$ENDIF}
  RegisterSelectionEditor(TCustomdxComponentPrinter, TdxSkinsPrintingSystemSelectionEditor);
end;

end.
